//  ⨢, ४ᨢ  ⮬⭮ ⬮ 
// 襭   室 .
//  ᪨  ᫥㥬  ⨬樨   㭪樨 main().

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// ࠬ ணࠬ.
enum { MOVE_TYPES = 8,                  // ⢮  室 .
       DESK_SIZE = 101,                 // ᨬ ࠧ ᪨.
       MAX_MOVES = DESK_SIZE*DESK_SIZE, // ᨬ쭮 ⢮ 室.
       MAX_RET = 400000,                // ࠭祭  ⢮ ⮢.
       GOOD_RET = 1,                    // ॡ㥬 ⢮ ⮢ 
                                        // ⨬樨  ᬥ ᨢ 室.
       MOVE_ARRAYS = 5                  // ⢮ ᨢ 室 .
     } ;

// ᨢ, 騥 室 .
int possible_moves[MOVE_TYPES+1][2] ;
int possible_moves_sh[][2] = {
{-1, -2}, {-2, -1}, {-2,  1}, { 1, -2},
{-1,  2}, { 2, -1}, { 1,  2}, { 2,  1} };
int possible_moves_tuk1[][2] = {
{ 1, -2}, { 2, -1}, { 2,  1}, { 1,  2},
{-1,  2}, {-2,  1}, {-2, -1}, {-1, -2} };
int possible_moves_tuk2[][2] = {
{-1, -2}, {-2, -1}, {-2,  1}, {-1,  2},
{ 1,  2}, { 2,  1}, { 2, -1}, { 1, -2} };
int possible_moves_tuk3[][2] = {
{-1,  2}, {-2,  1}, {-2, -1}, {-1, -2},
{ 1, -2}, { 2, -1}, { 2,  1}, { 1,  2} };
int possible_moves_tuk4[][2] = {
{ 1,  2}, { 2,  1}, { 2, -1}, { 1, -2},
{-1, -2}, {-2, -1}, {-2,  1}, {-1,  2} };

int *move_arrays[] =  { &possible_moves_sh[0][0], &possible_moves_tuk1[0][0],
                        &possible_moves_tuk2[0][0], &possible_moves_tuk3[0][0],
                        &possible_moves_tuk4[0][0] } ;

int size_x, size_y ;               //  ᪨.
int varnsdorf_moves[MAX_MOVES+1] ; // ᯮ⥫ ᨢ ஢ 室 
                                   //  ⨬樨 ᤮.
int moves_weights[MOVE_TYPES+1] ;  // ᯮ⥫ ᨢ  ⨬樨 
                                   // ᤮.
int moves_priority[MAX_MOVES+1][MOVE_TYPES+1] ;
                                   // ᯮ⥫ ᨢ, ᮤঠ騩 
                                   // ᫥⥫쭮 ॡ ⨯ 室,
                                   //  ⨬樨 ᤮.
int moves[MAX_MOVES+1] ;           // ᨢ, ࠭騩 ⨯ 室   
                                   //  ᮢ襭 室.
int move_num = 0 ;                 //  ⥪饣 室.
int max_moves ;                    // ᫮ 室, 室  室 ᪨.
int desk_state[DESK_SIZE+1][DESK_SIZE+1] ;
                                   // ﭨ ᪨  㪠  .
int start_x, start_y ;             // 砫쭠 ⪠.
int cur_x, cur_y ;                 //  ⪠.
int back_ret ;                     // ⢮ ⮢.

// ஢ઠ ⨬ 㪠 न ⪨.
int position_possible( int x, int y )
{
  return x > 0 && y > 0 && x <= size_x && y <= size_y ;
}

// ஢ઠ ⨬ 㪠 室.
int move_possible( int x, int y )
{
  //  , ᫨:
  //  - ⪠  ;
  //  - ⪠  ;
  return position_possible( x, y ) && desk_state[x][y] == 0 ;
}

// ⬥ 室.
int undo_move()
{
  int  prev_move_type = moves[move_num-1] ;

  //printf( "⬥ 室 %d  (%d, %d)\n", move_num, cur_x, cur_y ) ;
  desk_state[cur_x][cur_y] = 0 ;
  cur_x -= possible_moves[prev_move_type][0] ;
  cur_y -= possible_moves[prev_move_type][1] ;
  moves[move_num] = -1 ;
  back_ret++ ;

  return position_possible( cur_x, cur_y ) ;
}

// ஢,  ᮧ  蠣  㪠  ஢ ⪨.
//  ⥫쭠 ⨬,    ᯥ譮 襭 ᪠.
int move_make_closed_pole( int x, int y )
{
  if( move_num >= max_moves-2 ) return 0 ; //  ஢  ᫥ 室.

  // ன  ᥬ ᢮ ⪠,      [x,y].
  for( int i = 0 ; i < MOVE_TYPES ; i++ )
  {
    int x_near, y_near ;
    int near_count ;

    x_near = x + possible_moves[i][0] ;
    y_near = y + possible_moves[i][1] ;

    if(    !position_possible( x_near, y_near )
        || desk_state[x_near][y_near] != 0 ) continue ;

    //   ⠪ ⮪  ᫮ ⮪,   
    //     (஬ ⮩,  ன 諨).
    // ஢   ⮪,  ᮤঠ  
    // ⢥ 室,  ᫨ ᮤঠ,    
    // 室 蠣  । .
    near_count = 0 ;
    for( int j = 0 ; j < MOVE_TYPES ; j++ )
    {
      int x_near2, y_near2 ;

      x_near2 = x_near + possible_moves[j][0] ;
      y_near2 = y_near + possible_moves[j][1] ;

      if(    position_possible( x_near2, y_near2 )
          && desk_state[x_near2][y_near2] == 0
          && (x_near2 != x || y_near2 != y))
      {
        // த ஢, । 稥 易 
        // ஢ ⮪.
      
        int near_count2 = 0 ;

        for( int k = 0 ; k < MOVE_TYPES ; k++ )
        {
          int x_near3, y_near3 ;

          x_near3 = x_near2 + possible_moves[k][0] ;
          y_near3 = y_near2 + possible_moves[k][1] ;

          if(    position_possible( x_near3, y_near3 )
              && desk_state[x_near3][y_near3] == 0
              && (x_near3 != x || y_near3 != y)
              && (x_near3 != x_near || y_near3 != y_near ))
          {
            near_count2++ ;
            break ;
          }
        }

        if( near_count2 != 0 )
        {
          near_count++ ;
          break ;
        }
      }
    }
    if( near_count == 0 ) return 1 ;
  }

  return 0 ;
}

//  室, ᯮ ᫥⥫  ॡ ਠ⮢ 室.
// ࠬ - 㪠⥫  㭪 ⥫쭮 ⨬樨.
int make_move( int (*optim_func)(int, int) )
{
  //   室   ⪨ 㬥 ᫠  0  MOVE_TYPES.
  //  室 ॡ ᫥⥫쭮.
  // ᫨ ⨯ ஡㥬 室  MOVE_TYPES, ᫥⥫쭮 㦥 뫨 
  // ஡  室.
  for( int i = moves[move_num] + 1 ; i < MOVE_TYPES ; i++ )
  {
    int   x = cur_x, y = cur_y ;

    x += possible_moves[i][0] ;
    y += possible_moves[i][1] ;

    if( move_possible( x, y ) && ( !optim_func || !optim_func( x, y )))
    {
      cur_x = x ; cur_y = y ;
      moves[move_num] = i ;
      desk_state[x][y] = move_num+1 ;
      //printf( " %d  (%d, %d)\n", move_num+1, x, y ) ;
      return 1 ;
    }
  }

  return 0 ;
}

//  室, ᯮ  ॡ ਠ⮢ 室  ࠢ ᤮.
// ࠬ - 㪠⥫  㭪 ⥫쭮 ⨬樨.
int make_move_varnsdorf( int (*optim_func)(int, int) )
{
  int i,j;

  // ஢  室  ਮ 
  //  ᮮ⢥⢨  ࠢ ᤮.
  if( moves[move_num] < 0 )
  {
    varnsdorf_moves[move_num] = -1 ;

    //  ᨢ ਮ 室 
    // ᨢ  室  ᥤ ⮪.
    for( i = 0 ; i < MOVE_TYPES ; i++ )
    {
      moves_weights[i] = 0 ;
      moves_priority[move_num][i] = -1 ;

      int   x = cur_x, y = cur_y ;
      x += possible_moves[i][0] ;
      y += possible_moves[i][1] ;

      if( move_possible( x, y ))
      {
        // ᫨ 室 , ᫨   ⢮ 
        // 室  ⪨ 祭.
        moves_priority[move_num][i] = i ;
        for( int j = 0 ; j < MOVE_TYPES ; j++ )
        {
          int   nx = x, ny = y ;

          nx += possible_moves[j][0] ;
          ny += possible_moves[j][1] ;
          if( move_possible( nx, ny )) moves_weights[i]++ ;
        }
      }
    }

    // ஢ ᨢ ਮ 室  ⠭ ⢠ 室.
    for( i = 0 ; i < MOVE_TYPES ; i++ )
      for( j = 0 ; j < MOVE_TYPES-1 ; j++ )
        if( moves_weights[j] > moves_weights[j+1] )
        {
          int x ;
          x = moves_weights[j+1] ; 
          moves_weights[j+1] = moves_weights[j] ; 
          moves_weights[j] = x ;
          x = moves_priority[move_num][j+1] ;
          moves_priority[move_num][j+1] = moves_priority[move_num][j] ;
          moves_priority[move_num][j] = x ;
        }
  }

  // ॡ 室.
  for( i = varnsdorf_moves[move_num] + 1 ; i < MOVE_TYPES ; i++ )
  {
    if( moves_priority[move_num][i] < 0 ) continue ;

    int   x = cur_x, y = cur_y ;

    x += possible_moves[moves_priority[move_num][i]][0] ;
    y += possible_moves[moves_priority[move_num][i]][1] ;

    if( move_possible( x, y ) && ( !optim_func || !optim_func( x, y )))
    {
      cur_x = x ; cur_y = y ;
      moves[move_num] = moves_priority[move_num][i] ;
      varnsdorf_moves[move_num] = i ;
      desk_state[x][y] = move_num+1 ;
      return 1 ;
    }
  }

  return 0 ;
}

//   襭  砫쭮 ⪨.
int solution_impossible()
{
  // ᫨ ந ஭ ᪨ ⭮  㬬 न 砫쭮 樨
  // ⭠,  襭  .
  return ((size_x*size_y) % 2 != 0) && ((start_x+start_y) % 2 != 0) ;
}


//======
// H 

//===
//  , ᯮ ⨢ .
//  ࠬ - 㭪 믮 室.
// ன ࠬ - 㭪 ⨬樨.
// ⨩ ࠬ - ࠭祭  ⢮ ⮢.
void find_path( int move_func(int (*f)(int, int)), 
                int (*optim_func)(int, int), 
                int limit )
{
  //printf( "砫 室 (%d, %d)\n", cur_x, cur_y ) ;

  if( solution_impossible() ) return ;  // ஢,   襭.

  for( move_num = 1 ; move_num <= max_moves ; )
  {
    if( back_ret > limit ) return ;     // ஢,  ॢ襭  ࠭祭
                                        //  ⢮ ⮢. 
    if( move_func( optim_func ))        //  室.
      move_num++ ;
    else
      if( move_num > 1 )
      {
        //  । ⪨ ॡ࠭   室 - ⬥ 室.
        undo_move() ;
        move_num-- ;
      }
      else
        return ;
  }
}

//======
// H 

int find_path_rec( int cur_x, int cur_y, int cur_move_num )
{
  move_num = desk_state[cur_x][cur_y] = cur_move_num ; //  室.
  if( cur_move_num > max_moves ) return 1 ;            // ஢ 襭 室.

  // ஢   室  ⥪饩 ⪨.
  for( int i = 0 ; i < MOVE_TYPES ; i++ )      
  {
    int next_x = cur_x + possible_moves[i][0] ; // । ᫥饥 .
    int next_y = cur_y + possible_moves[i][1] ;

    if(    move_possible( next_x, next_y ) 
        && find_path_rec( next_x, next_y, move_num+1 )) return 1 ;
  }

  // .
  desk_state[cur_x][cur_y] = 0 ;
  move_num-- ;
  back_ret++ ;
  return 0 ; 
}


//======
// H 

//===
// 㭪樨, ॠ騥 室 ६.
int x1() { return move_num > max_moves ; }
int x2() { return move_num > 1 ; }
int x4() { return solution_impossible() ; }
int x5( int limit ) { return back_ret > limit ; }

//===
// 㭪樨, ॠ騥 室 ⢨.
void z1_0() { move_num = 1 ; }
void z1_1() { move_num++ ; }
void z1_2() { move_num-- ; }
void z2() { undo_move() ; }

int y = 0 ;

//===
// ⮬⭠ 㭪 宦 .
//  ࠬ - 㭪 믮 室.
// ன ࠬ - 㭪 ⨬樨.
// ⨩ ࠬ - ࠭祭  ⢮ ⮢.
void find_path_switch( int x3(int (*f)(int, int)), 
                       int (*optim_func)(int, int), 
                       int limit )
{
  y = 0 ;

  do
    switch( y )
    {
      case 0:
        if( x4())                    y = 3 ;
        else
        { z1_0() ;                   y = 1 ; }
      break ;

      case 1:
        if( x1())                    y = 4 ;
        else
        if( x3(optim_func)) { z1_1() ; }
        else
        if( x2()) { z2() ; z1_2() ;  y = 2 ; }
        else                         y = 3 ;
      break ;

      case 2:
        if( x5(limit))               y = 5 ;
        else                         y = 1 ;
      break ;

      case 3:                        y = 0 ; break ;
      case 4:                        y = 0 ; break ;
      case 5:                        y = 0 ; break ;
    }
  while( y < 3 ) ;
}


// 樠 .
void init( int sx, int sy )
{
  memset( desk_state, 0, sizeof(desk_state)) ;
  memset( moves, -1, sizeof(moves)) ;
  memset( varnsdorf_moves, -1, sizeof(varnsdorf_moves)) ;
  memset( moves_weights, 0, sizeof(moves_weights)) ;
  memset( moves_priority, 0, sizeof(moves_priority)) ;
  back_ret = 0 ;
  move_num = 0 ;
  start_x = cur_x = sx ;
  start_y = cur_y = sy ;
  desk_state[cur_x][cur_y] = 1 ;
  max_moves = size_x * size_y - 1 ;
}

// 뢥 .
void output()
{
  int i, j ;

  printf( "\n  (%d, %d), ⮢ %d:\n", start_x, start_y, back_ret ) ;
  for( i = 1 ; i <= size_y ; i++ )
  {
    for( j = 1 ; j <= size_x ; j++ )
      printf( "%-5d", desk_state[j][i] ) ;
    printf( "\n\n" ) ;
  }
}

// ⠭  롮 ᯮ㥬 ⮤ ⨬樨.
enum { SIMPLE, SIMPLE_OPTIMIZED, VARNSDORF, 
       VARNSDORF_OPTIMIZED, ARRAY_CHANGE, SWITCH, RECURSE } ;

// 뢥 ⢮ ⮢   ⮪ ᪨.
// ࠬ - ᯮ㥬 .
void find_solution( int method )
{
  int  i, j, k ;
  char used_array = 0 ;

  for( i = 1 ; i <= size_y ; i++ )
  {
    for( j = 1 ; j <= size_x ; j++ )
    {
      init( j, i ) ;
      switch( method )
      {
        case SIMPLE:              
          find_path( make_move, NULL, MAX_RET ) ; 
        break ;
        case SIMPLE_OPTIMIZED:    
          find_path( make_move, move_make_closed_pole, MAX_RET ) ; 
        break ;
        case VARNSDORF:           
          find_path( make_move_varnsdorf, NULL, MAX_RET ) ; 
        break ;
        case VARNSDORF_OPTIMIZED: 
          find_path( make_move_varnsdorf, move_make_closed_pole, MAX_RET ) ; 
        break ;
        case ARRAY_CHANGE:
          used_array = 'A'-1 ; k = 0 ;
          while( k < MOVE_ARRAYS )
          {
            int ret_count = k < MOVE_ARRAYS-1 ? GOOD_RET : MAX_RET ;
            used_array++ ;
            init( j, i ) ;
            memcpy( possible_moves, move_arrays[k], sizeof( possible_moves_sh )) ;
            find_path( make_move_varnsdorf, move_make_closed_pole, ret_count ) ;
            if( back_ret <= ret_count ) break ;
            k++ ;
          }

          printf( "%c", used_array == 'A' ? ' ' : used_array ) ;
        break ;

        case SWITCH:
          used_array = 'A'-1 ; k = 0 ;
          while( k < MOVE_ARRAYS )
          {
            int ret_count = k < MOVE_ARRAYS-1 ? GOOD_RET : MAX_RET ;
            used_array++ ;
            init( j, i ) ;
            memcpy( possible_moves, move_arrays[k], sizeof( possible_moves_sh )) ;
            find_path_switch( make_move_varnsdorf, move_make_closed_pole, ret_count ) ;
            if( y == 4 ) break ;
            k++ ;
          }

          used_array = used_array == 'A' ? ' ' : used_array ;
          switch( y )
          {
            case 3: printf( " %-7c", 'N' ) ; break ;
            case 4: printf( "%c%-7d", used_array, back_ret ) ; break ;
            case 5: printf( "%c%-7s", used_array, "LIM" ) ; break ;
          }
          flushall() ;
        continue ;  // த 横 for, ⮡  믮﫮 ,  ᫥ 
                    //  switch.
 
        case RECURSE:
          find_path_rec( start_x, start_y, 1 ) ; 
        break ;
      }

      if( back_ret > MAX_RET )
        printf( "%-7s", "LIM" ) ;
      else if( move_num > 1 )
        printf( "%-7d", back_ret ) ;
      else
        printf( "%-7c", 'N' ) ;

      flushall() ;
    }

    printf( "\n" ) ;
  }

  return ;
}

//  㭪樨 main()  ࠧ ᪨  ⨯ 믮塞 ᫥.

int main()
{
  size_x = 6 ;
  size_y = 6 ;

  memcpy( possible_moves, possible_moves_sh, sizeof( possible_moves_sh )) ;

  // ⨢   ਬ ࠧ ⮤ ⨬樨.
  printf( "\n⨬ 1\n" ) ;
  find_solution( SIMPLE ) ;
  printf( "\n⨬ 1  2\n" ) ;
  find_solution( SIMPLE_OPTIMIZED ) ;
  printf( "\n⨬ 1  3\n" ) ;
  find_solution( VARNSDORF ) ;
  printf( "\n⨬ 1-3\n" ) ;
  find_solution( VARNSDORF_OPTIMIZED ) ;
  printf( "\n⨬ 1-4\n" ) ;
  find_solution( ARRAY_CHANGE ) ;
  output() ;

  // ⮬   ⨬ﬨ 1-4.
  printf( "\n⮬⭠ ணࠬ. ⨬ 1-4\n" ) ;
  find_solution( SWITCH ) ;
  output() ;

  // ᨢ   ⨬樨.
  printf( "\nᨢ ணࠬ\n" ) ;
  find_solution( RECURSE ) ;
  output() ;

  // ஥     砫쭮 ⪨  ࠭묨
  // ⮤ ⨬樨.
  /*
  init( 5, 2 ) ;
  find_path( make_move, NULL, 1000000000 ) ; 
  output() ;
  */

  return 0;
}
